// Generic SCO Script 
// Copyright 2001,2002 Click2learn, Inc.
// concocted by Claude Ostyn 2002-10-04
//
// How to use:
// Include this script in the script of the 
// "top level" HTML document of your SCO.
// Put calls to LMSInitialize() and LMSFinish()
// in onLoad, onBeforeUnload and onUnload attributes of
// the <body> or <frameset> of your HTML document.
// If the API found, you can call the API "catcher" functions 
// in this script directly
// e.g. just call 'LMSGetValue("cmi.core.score.raw")'
// See examples at http://home.click2learn.com/standardswork.

////// Pseudo-constants
// Change values to suit your taste and requirements.

var B_SHOW_API_ERRORS = false; // change to true to show errors
var STR_API_NOT_FOUND = "Management system interface not found."
var STR_API_TOO_DEEP = "Cannot find API - too deeply nested."
var STR_API_INIT_FAILED = "Found API but LMSInitialize failed."

/////////// API INTERFACE INITIALIZATION AND CATCHER FUNCTIONS ////////
var znFindAPITries = 0;
var zobjAPI = null;
var zbInitDone = false;   // will be true if LMSInitialize succeeded
var zbFinishDone = false; // will be true after LMSFinish succeeded

function AlertUserOfAPIError(strText) {
	if (B_SHOW_API_ERRORS) {alert(strText)}
}

function FindAPI(win) {
	while ((win.API == null) && (win.parent != null) && (win.parent != win)) {
		znFindAPITries ++;
		if (znFindAPITries > 500) {
			AlertUserOfAPIError(STR_API_TOO_DEEP);
			return null;
		} 
		win = win.parent;
	}
	return win.API;
}

function APIOK() {
	return ((typeof(zobjAPI)!= "undefined") && (zobjAPI != null))
}

function LMSInitialize(parm) {
	var err = "false"
	if (!zbInitDone)
	{
		if ((window.parent != null) && (window.parent != window)) {
			zobjAPI = FindAPI(window.parent)
		}
		if ((zobjAPI == null) && (window.opener != null)){
			zobjAPI = FindAPI(window.opener)
		}
		if (!APIOK()) {
			AlertUserOfAPIError(STR_API_NOT_FOUND)
		} else {
			err = zobjAPI.LMSInitialize("");
			if (err == "true") {
				zbInitDone = true;
				if (typeof(SCO_InitData) != "undefined"){
					// This is your own function in the main script of your SCO,
					// where you get can data from the LMS once the API
					// communication has been initialized.
					SCO_InitData();
				}
			} else {
				AlertUserOfAPIError(STR_API_INIT_FAILED)
			}
		}
	}
	return (err + "") // Force type to string
}

function LMSFinish(parm) {
	if ((APIOK()) && (zbFinishDone == false)) {
		if (typeof(SCO_SaveData) != "undefined"){
					// This is your own function in the main script of your SCO,
					// where you save any pending data to the LMS before
					// API communication is terminated.
			SCO_SaveData();
		}
		zbFinishDone = (zobjAPI.LMSFinish("") != "false");
	}
	return (zbFinishDone + "" ) // Force type to string
}

// Call these catcher functions rather than trying to call the API adapter directly
function LMSSetValue(n,v)			{return ((APIOK())?zobjAPI.LMSSetValue(n,v):"false")}
function LMSGetValue(nam)			{return ((APIOK())?zobjAPI.LMSGetValue(nam):"")}
function LMSCommit(parm)			{return ((APIOK())?zobjAPI.LMSCommit(""):"false")}
function LMSGetLastError(parm){return ((APIOK())?zobjAPI.LMSGetLastError(""):"-1")}
function LMSGetErrorString(n)	{return ((APIOK())?zobjAPI.LMSGetErrorString(n):"No LMS")}
function LMSGetDiagnostic(n)	{return ((APIOK())?zobjAPI.LMSGetDiagnostic(n):"No LMS")}

